# wxSearchCtrl Class Reference
[Controls]

`#include <wx/srchctrl.h>`

Inheritance diagram for wxSearchCtrl:
[legend]

## Detailed Description

A search control is a composite control with a search button, a text control, and a cancel button.

## Styles

This class supports the following styles:

- wxTE_PROCESS_ENTER:
  The control will generate the event `wxEVT_COMMAND_TEXT_ENTER` (otherwise pressing Enter key is either processed internally by the control or used for navigation between dialog controls).
- wxTE_PROCESS_TAB:
  The control will receive `wxEVT_CHAR` events for TAB pressed - normally, TAB is used for passing to the next control in a dialog instead. For the control created with this style, you can still use Ctrl-Enter to pass to the next control from the keyboard.
- wxTE_NOHIDESEL:
  By default, the Windows text control doesn't show the selection when it doesn't have focus - use this style to force it to always show it. It doesn't do anything under other platforms.
- wxTE_LEFT:
  The text in the control will be left-justified (default).
- wxTE_CENTRE:
  The text in the control will be centered (currently wxMSW and wxGTK2 only).
- wxTE_RIGHT:
  The text in the control will be right-justified (currently wxMSW and wxGTK2 only).
- wxTE_CAPITALIZE:
  On PocketPC and Smartphone, causes the first letter to be capitalized.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxCommandEvent& event)
Event macros for events emitted by this class:
To retrieve actual search queries, use EVT_TEXT and EVT_TEXT_ENTER events, just as you would with wxTextCtrl.

- EVT_SEARCHCTRL_SEARCH_BTN(id, func):
  Respond to a `wxEVT_SEARCHCTRL_SEARCH_BTN` event, generated when the search button is clicked. Note that this does not initiate a search on its own, you need to perform the appropriate action in your event handler. You may use

       event.GetString()

  to retrieve the string to search for in the event handler code.
- EVT_SEARCHCTRL_CANCEL_BTN(id, func):
  Respond to a `wxEVT_SEARCHCTRL_CANCEL_BTN` event, generated when the cancel button is clicked.

##

Library: wxCore

Category: Controls
Appearance:

wxMSW appearance | wxGTK appearance | wxMac appearance

See also:
  wxTextCtrl::Create, wxValidator

## Public Member Functions
| wxSearchCtrl ()
| Default constructor.
| wxSearchCtrl (wxWindow *parent, wxWindowID id, const wxString &value=wxEmptyString, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxSearchCtrlNameStr)
| Constructor, creating and showing a text control.
virtual | ~wxSearchCtrl ()
| Destructor, destroying the search control.
virtual wxMenu * | GetMenu ()
| Returns a pointer to the search control's menu object or NULL if there is no menu attached.
virtual bool | IsSearchButtonVisible () const
| Returns the search button visibility value.
virtual void | SetMenu (wxMenu *menu)
| Sets the search control's menu object.
virtual void | ShowCancelButton (bool show)
| Shows or hides the cancel button.
virtual void | ShowSearchButton (bool show)
| Sets the search button visibility value on the search control.

List of all members.

## Constructor & Destructor Documentation

wxSearchCtrl::wxSearchCtrl | ( |  | ) |

Default constructor.

wxSearchCtrl::wxSearchCtrl | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxString & | value = `wxEmptyString`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxValidator & | validator = `wxDefaultValidator`,
|  | const wxString & | name = `wxSearchCtrlNameStr` |
| ) |  |  |

Constructor, creating and showing a text control.

Parameters:

  | parent | Parent window. Should not be NULL.
  | id | Control identifier. A value of -1 denotes a default value.
  | value | Default text value.
  | pos | Text control position.
  | size | Text control size.
  | style | Window style. See wxSearchCtrl.
  | validator | Window validator.
  | name | Window name.

See also:
  wxTextCtrl::Create, wxValidator

virtual wxSearchCtrl::~wxSearchCtrl | ( |  | ) | `[virtual]`

Destructor, destroying the search control.

## Member Function Documentation

virtual wxMenu* wxSearchCtrl::GetMenu | ( |  | ) | `[virtual]`

Returns a pointer to the search control's menu object or NULL if there is no menu attached.

virtual bool wxSearchCtrl::IsSearchButtonVisible | ( |  | ) | const`[virtual]`

Returns the search button visibility value.

If there is a menu attached, the search button will be visible regardless of the search button visibility value.

This always returns false in Mac OS X v10.3

virtual void wxSearchCtrl::SetMenu | ( | wxMenu * | menu | ) | `[virtual]`

Sets the search control's menu object.

If there is already a menu associated with the search control it is deleted.

Parameters:

  | menu | Menu to attach to the search control.

virtual void wxSearchCtrl::ShowCancelButton | ( | bool | show | ) | `[virtual]`

Shows or hides the cancel button.

virtual void wxSearchCtrl::ShowSearchButton | ( | bool | show | ) | `[virtual]`

Sets the search button visibility value on the search control.

If there is a menu attached, the search button will be visible regardless of the search button visibility value.

This has no effect in Mac OS X v10.3

|  | [ top ]